=== debian/changelog ===
jitterentropy-library (3.6.3-1) unstable; urgency=low

  * Initial release. Closes: #1109483

 -- Eric Berry <eric.berry@canonical.com>  Wed, 13 Aug 2025 08:36:43 -0700
