=== debian/control ===
Source: jitterentropy-library
Section: libs
Priority: optional
Maintainer: Eric Berry <eric.berry@canonical.com>
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.7.2
Homepage: https://github.com/smuellerDD/jitterentropy-library
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debian/jitterentropy-library.git
Vcs-Browser: https://salsa.debian.org/debian/jitterentropy-library

Package: libjitterentropy3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Jitter RNG provides a noise source using the CPU
 execution timing jitter. It does not depend on any system resource
 other than a high-resolution time stamp. It is a small-scale, yet
 fast entropy source that is viable in almost all environments and
 on a lot of CPU architectures.
 .
 The implementation of the Jitter RNG is independent of any operating
 system. As such, it could even run on baremetal without any operating
 system.
 .
 The design of the RNG is given in the documentation found in at
 http://www.chronox.de/jent . This documentation also covers the full
 assessment of the SP800-90B compliance as well as all required test
 code.

Package: libjitterentropy3-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libjitterentropy3 (= ${binary:Version}), ${misc:Depends}
Description: libjitterentropy3 development files
 This package contains the development headers, static libraries, and
 symbolic links required to compile and link applications against
 libjitterentropy3. It provides the necessary files for building software that
 utilizes the libjitterentropy3 API.
