=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,-O1

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr LIBDIR=lib/$(DEB_HOST_MULTIARCH)

execute_after_dh_auto_install:
	$(MAKE) install-static DESTDIR=$(CURDIR)/debian/tmp PREFIX=/usr LIBDIR=lib/$(DEB_HOST_MULTIARCH)
