=== debian/watch ===
version=4
https://github.com/smuellerDD/jitterentropy-library/tags https://github.com/smuellerDD/jitterentropy-library/archive/refs/tags/v(\d+).(\d+).(\d+).tar.gz
